#define DT_DRV_COMPAT buzzer_piezo

#include <zephyr/device.h>

#include <zephyr/devicetree.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/kernel.h>
#include <zephyr/logging/log.h>

#include <app/drivers/buzzer.h>

LOG_MODULE_REGISTER(buzzer_piezo, CONFIG_BUZZER_LOG_LEVEL);

struct buzzer_piezo_data {
  bool state;
};

struct buzzer_piezo_config {
  struct gpio_dt_spec pin1, pin2;
  unsigned int ppi_channel1, ppi_channel2;
  unsigned int gpiote_channel1, gpiote_channel2;
  struct device *timer_dev;
  struct device *ppi;
  struct device *gpiote;
};

static int buzzer_piezo_set(const struct device *dev, bool state) {
  const struct buzzer_piezo_config *config = dev->config;
  struct buzzer_piezo_data *data = dev->data;

  return 0;
}

static const struct buzzer_driver_api buzzer_piezo_api = {
    .set = &buzzer_piezo_set,
};

static int buzzer_piezo_init(const struct device *dev) {
  const struct buzzer_piezo_config *config = dev->config;
  struct buzzer_piezo_data *data = dev->data;

  return 0;
}

#define BUZZER_PIEZO_DEFINE(inst)                                              \
  static struct buzzer_piezo_data data##inst;                                  \
                                                                               \
  static const struct buzzer_piezo_config config##inst = {                     \
      .pin1 = GPIO_DT_SPEC_INST_GET_BY_IDX(inst, gpios, 0),                    \
      .pin2 = GPIO_DT_SPEC_INST_GET_BY_IDX(inst, gpios, 1),                    \
      .gpiote_channel1 = ?,                                                    \
      .gpiote_channel2 = ?,                                                    \
      .ppi_channel1 =    ?,                                                    \
      .ppi_channel2 =    ?,                                                    \
      .ppi =             ?,                                                    \
      .gpiote =          ? };                                                  \
                                                                               \
  DEVICE_DT_INST_DEFINE(inst, buzzer_piezo_init, NULL, &data##inst,            \
                        &config##inst, POST_KERNEL,                            \
                        CONFIG_BUZZER_INIT_PRIORITY, &buzzer_piezo_api);

DT_INST_FOREACH_STATUS_OKAY(BUZZER_PIEZO_DEFINE)
